<?php
  /**
   * This page displays the form for adding a request,
   * and also handles the form.
   * @author Jason Grafinger
   */

  session_start();

  require("./include/include.php");

  //Secure page...
  checkAuth();

  $conn = connect($master);

  //ONLY standard users can add requests
  if($_SESSION['userType'] == "std" && !isset($_GET['formsubmitted']))
  {
    //Display form

    $pgTitle = "Add request form";
    writeTop($pgTitle,false,$master,$_GET['error']);
    writeNav($_SESSION['userType']);
    foreach(array_keys($_GET) as $field)
    {
      $_GET[$field] = stripslashes(html_entity_decode(urldecode($_GET[$field])));
    }

    //Now figure out what the next three days are going to be.
    $startDate = strtotime("now");
    $firstDay = date("l \\t\h\e jS",getTimestampForXWeekdays(1,$startDate));
    $secondDay = date("l \\t\h\e jS",getTimestampForXWeekdays(2,$startDate));
    $thirdDay = date("l \\t\h\e jS",getTimestampForXWeekdays(3,$startDate));

    $formHTML = "      <hr />
      <form action=\"{$_SERVER['PHP_SELF']}?formsubmitted=t\" " .
      "method=\"post\">
        <p>
          <b>Note:</b> The three input boxes regarding schedules must
          be in the format of &quot;<i><u>HH:MM[A/P]M - HH:MM[A/P]M
          </u></i>&quot;.  You may have multiple timespans in this format
          if separated by a semi-colon (&quot;;&quot;).
        </p>
        <p>
          <label>Schedule for {$firstDay}</label><br />
          <input type=\"text\" name=\"firstDay\" size=\"75\" value=\"{$_GET['firstDay']}\" />
        </p>
        <p>
          <label>Schedule for {$secondDay}</label><br />
          <input type=\"text\" name=\"secondDay\" size=\"75\" value=\"{$_GET['secondDay']}\" />
        </p>
        <p>
          <label>Schedule for {$thirdDay}</label><br />
          <input type=\"text\" name=\"thirdDay\" size=\"75\" value=\"{$_GET['thirdDay']}\" />
        </p>
        <label>Notes</label><br />
        <textarea name=\"notes\" rows=\"10\" cols=\"80\">{$_GET['notes']}</textarea>
        <p>
          <input type=\"submit\" value=\"Submit\" />
        </p>
      </form>\n";

    echo $formHTML;
    writeBottom();
  }

  else if($_SESSION['userType'] == "std" && isset($_GET['formsubmitted']) &&
    $_GET['formsubmitted'] == "t")
  {
    //Handle form

    $validForm = true;

    //Must have at least ONE schedule filled out
    if($_POST['firstDay'] == "" && $_POST['secondDay'] == "" &&
      $_POST['thirdDay'] == "")
    {
      $validForm = false;
    }

    //Validate time through regular expressions
    foreach(array_keys($_POST) as $field)
    {
      //Make sure the time spans match the requred format
      if(strstr($field,"Day") && $_POST[$field] != "")
      {
        $doesMatch = isValidTimespanFormat($_POST[$field]);
        $validForm = $validForm && $doesMatch;
      }
    }

    if(!$validForm)
    {
      //Redirect
      $queryString = "?error=badAddReq&";
      foreach(array_keys($_POST) as $field)
      {
        $queryString .= $field . "=" . urlencode(htmlentities($_POST[$field])) . "&";
      }

      $redirectString = $_SERVER['PHP_SELF'] . $queryString;
      header("Location: " . $redirectString);
    }
    else
    {
      $postedItems = array();
      foreach(array_keys($_POST) as $field)
      {
        $field = mysql_real_escape_string($field);
        $value = mysql_real_escape_string($_POST[$field]);
        if($_POST[$field] != "")
        {
          //Use htmlentities() to change HTML special chars
          // (e.g. '&' becomes '&amp;')
          $_POST[$field] = htmlentities($_POST[$field]);

          //Add to the array of what actually was posted
          $postedItems[$field] = $_POST[$field];
        }
      }

      //Process the form
      $nonStrings = array("requestTypeID","requestSubTypeID");
      $queryFields = "userID,dateIssued";
      $queryValues = $_SESSION['userID'] . ",'" . date("Y-m-d") . "'";
      foreach(array_keys($postedItems) as $field)
      {
        $queryFields .= "," . $field;
        if(in_array($field,$nonStrings))
        {
          $queryValues .= "," . $postedItems[$field];
        }
        else
        {
          $queryValues .= ",'" . $postedItems[$field] . "'";
        }
      }

      //Construct the final query
      $query = sprintf("INSERT INTO requests (requestStatusID,%s) VALUES (1,%s)",
        $queryFields,$queryValues);

      //Try to execute the insert
      $result = mysql_query($query);

      $error = "";
      if(!result)
      {
        //ERROR
        $error = "?error=badInsert";
      }

      //Redirect back, an error is only added if theres a problem
      header("Location: " . $master['systemRoot'] . $error);
    }
  }

  else
  {
    //Bad page, redirect.
    header("Location: " . $master['systemRoot'] . "?error=badPage");
  }
?>