<?php
  /**
   * Allows cancellation of a request along with an optional note
   * @author Jason Grafinger
   */

  function okayToCancelReq($reqID,$userID)
  {
    /**
     * Returns whether or not this user can cancel the req.
     * @return boolean Truth of permission to delete.
     */

    if(is_numeric($userID) && is_numeric($reqID))
    {
      //Check to see if the user has permission
      $query = "SELECT * FROM requests WHERE userID={$userID} AND " .
        "requestID={$reqID}";

      $result = mysql_query($query);
      if($result && mysql_num_rows($result) == 1)
      {
        //User owns the req, and has permission
        return true;
      }
      else
      {
        //User does not have permission
        return false;
      }
    }
    else
    {
      //Illegal arguments
      return false;
    }
  }

  session_start();

  require("./include/include.php");

  //Secure page...
  checkAuth();

  $conn = connect($master);

  //User hasn't selected 'yes'
  if(isset($_GET['requestID']) && is_numeric($_GET['requestID']) &&
    !isset($_GET['go']))
  {
    //Check to see if user has permission to delete
    $permissionToCancel = false;
    if($_SESSION['userType'] == "admin")
    {
      $permissionToCancel = true;
    }
    else
    {
      $permissionToCancel = okayToCancelReq($_GET['requestID'],
        $_SESSION['userID']);
    }

    //If permission granted, ask if they really want to delete
    if($permissionToCancel)
    {
      //HTML info
      $pgTitle = "Really Cancel?";
      $includeSystemName = false;
      writeTop($pgTitle,$includeSystemName,$master,$_GET['error']);
      writeNav($_SESSION['userType']);
      $pageHTML = "      <hr />
      <p>
        Do you really want to cancel request ID: {$_GET['requestID']}?
      </p>
      <form action=\"cancelrequest.php?requestID={$_GET['requestID']}" .
        "&amp;go=t\" method=\"post\">
        <p>
          <label>Extra notes</label><br />
          <textarea name=\"extraNotes\" cols=\"75\" rows=\"10\"></textarea>
        </p>
        <p>
          <input type=\"submit\" value=\"YES\" /> |
          <a href=\"viewrequests.php?requestID={$_GET['requestID']}\">NO</a>
        </p>
      </form>\n";
      echo $pageHTML;
      writeBottom();
    }
    else
    {
      //No permission, redirect
      header("Location: " . $master['systemRoot'] . "?error=badPage");
    }
  }

  //Go ahead and delete the req
  else if(isset($_GET['requestID']) && is_numeric($_GET['requestID']) &&
    isset($_GET['go']) && $_GET['go'] == "t")
  {
    //Check to see if user has permission to delete
    $permissionToCancel = false;
    if($_SESSION['userType'] == "admin")
    {
      $permissionToCancel = true;
    }
    else
    {
      $permissionToCancel = okayToCancelReq($_GET['requestID'],
        $_SESSION['userID']);
    }

    //If permission granted, Cancel!
    if($permissionToCancel)
    {
      //Just for good measure...
      $reqID = mysql_real_escape_string($_GET['requestID']);
      $cancellationNotes = mysql_real_escape_string(
        htmlentities($_POST['extraNotes']));

      $query = "UPDATE requests SET requestStatusID=4, notes='" .
        $cancellationNotes . "' WHERE requestID=" . $reqID;
      $result = mysql_query($query);

      //Set an error code if cancellation failed
      $errorMsg = ($result) ? "" : "?error=cancel1";

      header("Location: " . $master['systemRoot'] . $errorMsg);
    }
    else
    {
      //No permission, redirect
      header("Location: " . $master['systemRoot'] . "?error=badPage");
    }
  }

  else
  {
    //Bad page, redirect.
    header("Location: " . $master['systemRoot'] . "?error=badPage");
  }
?>