<?php
  /**
   * Allows for edit of an appointment request for ADMINS ONLY
   * @author Jason Grafinger
   */

  session_start();

  require("./include/include.php");

  //Secure page...
  if($_SESSION['userType'] != "admin")
  {
    //redirect
    header("Location: " . $master['systemRoot'] . "?error=badPage");
  }

  $conn = connect($master);

  //////
  // HTML Mgmt
  //////

  //User hasn't submitted the form
  if(isset($_GET['requestID']) && is_numeric($_GET['requestID']) &&
    !isset($_GET['formsubmitted']))
  {
    //Req info
    $query = "SELECT requests.*,users.firstName,users.lastName," .
      "requestStatus.requestStatusName,requestStatus.closed " .
      "FROM requests " .
      "INNER JOIN requestStatus ON requests.requestStatusID=" .
      "requestStatus.requestStatusID " .
      "INNER JOIN users ON requests.userID=users.userID " .
      "WHERE requests.requestID=" . $_GET['requestID'];

    $result = mysql_query($query);

    if(!$result || mysql_num_rows($result) != 1)
    {
      //Bad result, or too many rows returned
      // Something goofed
      header("Location: " . $master['systemRoot'] . "?error=query");
    }

    //Result vars
    $row = mysql_fetch_assoc($result);

    //String stuff for the 3-day schedule
    $startDate = strtotime("now");
    $firstDay = date("l \\t\h\e jS",getTimestampForXWeekdays(1,$startDate));
    $secondDay = date("l \\t\h\e jS",getTimestampForXWeekdays(2,$startDate));
    $thirdDay = date("l \\t\h\e jS",getTimestampForXWeekdays(3,$startDate));

    //The following variables equal either the database value
    // OR the value specified in the query-string, depending
    // on whether the query-string is set
    $decodedNotes = (isset($_GET['notes'])) ?
      html_entity_decode(urldecode($_GET['notes'])) :
      html_entity_decode($row['notes']);

    //Page HTML stuff
    $pgTitle = "Edit Form for Request ID: " . $row['requestID'];
    $showSystemName = false;
    writeTop($pgTitle,$showSystemName,$master,$_GET['error']);
    writeNav($_SESSION['userType']);

    //Create the form
    $pageHTML = "      <hr />
        <fieldset>
          <legend>Request Info</legend>
          <p>
            <b>Name:</b>{$row['firstName']} {$row['lastName']}
          </p>
          <p>
            <b>Schedule for {$firstDay}:</b> {$row['firstDay']}
          </p>
          <p>
            <b>Schedule for {$secondDay}:</b> {$row['secondDay']}
          </p>
          <p>
            <b>Schedule for {$thirdDay}:</b> {$row['thirdDay']}
          </p>
        </fieldset>
        <fieldset>
          <legend>Edit Request</legend>
          <form action=\"editrequest.php?requestID={$_GET['requestID']}&amp;formsubmitted=t\" method=\"post\">\n";


    $pageHTML .= "            <p>
              <label>Status</label><br />
              <select name=\"requestStatusID\">
                <option value=\"-1\">---Please Select---</option>\n";

    //Get the possible status IDs
    $statusQuery = "SELECT * FROM requestStatus";
    $statusResult = mysql_query($statusQuery);
    if(!$statusResult || mysql_num_rows($statusResult) < 1)
    {
      header("Location: " . $master['systemRoot'] . "?error=query");
    }
    while($statusRow = mysql_fetch_assoc($statusResult))
    {
      $selectedHTML = "";
      if($statusRow['requestStatusName'] == $row['requestStatusName'])
      {
        $selectedHTML = " selected=\"true\" ";
      }
      $pageHTML .= "                " .
        "<option {$selectedHTML}value=\"{$statusRow['requestStatusID']}\">{$statusRow['requestStatusName']}</option>\n";
    }

    //Finish off the select for ALL userTypes
    $pageHTML .= "              </select>
        </p>\n";

    $pageHTML .= "            <p>
              <label>Notes</label><br />
              <textarea rows=\"10\" cols=\"70\" name=\"notes\">{$decodedNotes}</textarea>
            </p>
            <p>
              <input type=\"submit\" value=\"Submit Edit\" />
            </p>
          </form>
        </fieldset>
      ";

    echo $pageHTML;
    writeBottom();
  }



  //Handle the form
  else if(isset($_GET['requestID']) && is_numeric($_GET['requestID']) &&
    isset($_GET['formsubmitted']) && $_GET['formsubmitted'] == "t")
  {
    //Status can only be edited by an admin, but we must
    // validate the input (can't be '-1')
    $validRequestStatus = true;
    if($_POST['requestStatusID'] == "-1")
    {
      $validRequestStatus = false;
    }

    //Total form validity relies on individual tests
    $validForm = $validRequestStatus;

    if(!$validForm)
    {
      //Redirect string management
      $redirectString = $_SERVER['PHP_SELF'] . "?requestID=" .
        $_GET['requestID'] . "&error=editForm";
      foreach(array_keys($_POST) as $field)
      {
        if($field != "requestStatusID")
        {
            $redirectString .= "&" . $field . "=" .
            urlencode(htmlentities($_POST[$field]));
        }
      }
      //Redirect back
      header("Location: " . $redirectString);
    }
    else
    {
      $databaseFields = array("notes","requestStatusID");
      $finalEdits = array();
      foreach($databaseFields as $field)
      {
        $finalEdits[$field] = mysql_real_escape_string(htmlentities($_POST[$field]));
      }

      $wroteOnce = false;
      $updateQuery = "UPDATE requests SET ";

      foreach(array_keys($finalEdits) as $field)
      {
        if($wroteOnce)
        {
          $updateQuery .= ", ";
        }
        $updateQuery .= $field . "=";
        if($field != "requestStatusID")
        {
          $updateQuery .= "'";
        }
        $updateQuery .= $finalEdits[$field];
        if($field != "requestStatusID")
        {
          $updateQuery .= "'";
        }

        $wroteOnce = true;
      }

      //Non-Admins must mark the request as "updated"
      if($_SESSION['userType'] != "admin")
      {
        $updateQuery .= ",requestStatusID=4";
      }

      $updateQuery .= " WHERE requestID={$_GET['requestID']}";

      $result = mysql_query($updateQuery);
      if(!$result)
      {
        //Query error, redirect
        header("Location: " . $master['systemRoot'] . "?error=query");
      }
      else
      {
        //Success!  Redirect to view the updated request
        header("Location: " . $master['systemRoot'] . "viewrequests.php" .
          "?requestID=" . $_GET['requestID']);
      }
    }
  }

  else
  {
    //Bad page, redirect.
    header("Location: " . $master['systemRoot'] . "?error=badPage");
  }
?>