<?php
  /**
   * Index page.  Displays the login form to non-authenticated
   * users, and a relatively blank page to authenticated users
   * (with a menu of course).
   *
   * @author Jason Grafinger
   */

  //If createconfig.php is readable,
  // it is usually a new "install", so redirect to the create
  // configuration page.  If it is not a new install, then the redirected
  // page will prompt a user (with permission) to chmod the createconfig.php
  // to non-readable.
  if(is_readable("./createconfig.php"))
  {
    header("Location: createconfig.php");
  }

  //ELSE: Main function of index.php
  else
  {
    session_start();
    require("./include/include.php");

    //Check user authentication for page title.
    if(isset($_SESSION['userType']) && $_SESSION['userType'] == "admin")
    {
      $pgTitle = "ADMIN";
      $includeSystemName = false;
    }
    else if(isset($_SESSION['userType']) && $_SESSION['userType'] == "std")
    {
      $pgTitle = "Welcome to ";
      $includeSystemName = true;
    }
    else
    {
      $pgTitle = "Login for ";
      $includeSystemName = true;
    }

    writeTop($pgTitle,$includeSystemName,$master,$_GET['error']);

    //Write main page body
    if(!isset($_SESSION['userType']))
    {
      $pgHTML = "      <a href=\"register.php\">Register</a>
      <hr />
      <form action=\"authenticate.php?authType=std\" method=\"post\">
        <p>
          <label>Email Address</label><br />
          <input type=\"text\" name=\"email\" />
        </p>
        <p>
          <label>Password</label><br />
          <input type=\"password\" name=\"password\" />
        </p>
        <p>
          <input type=\"submit\" value=\"Log in\" />
        </p>
      </form>
      <p>
        <a href=\"adminlogin.php\">[Admin Login]</a>
      </p>\n";
    }
    else
    {
      writeNav($_SESSION['userType']); 
    }

    echo $pgHTML;

    writeBottom();
  }
?>
