<?php
  /**
   * This page displays and handles new account
   * registration.
   *
   * @author Jason Grafinger
   */

  require("./include/include.php");

  //If the form is not submitted, display the form
  if(!isset($_GET['formsubmitted']))
  {
    $pgTitle = "Registration for the ";
    $includeSystemName = true;
    writeTop($pgTitle,$includeSystemName,$master,$_GET['error']);

    $pgHTML = "      <form action=\"register.php?formsubmitted=t\" method=\"post\">
        <p>
          <label>First Name</label><br />
          <input type=\"text\" name=\"firstName\" /><br />

          <label>Last Name</label><br />
          <input type=\"text\" name=\"lastName\" /><br />

          <label>Email Address</label><br />
          <input type=\"text\" name=\"email\" />
        </p>
        <p>
          <input type=\"submit\" value=\"Register\" />
        </p>
      </form>\n";

    echo $pgHTML;

    writeBottom();
  }

  //If the form is submitted, handle the form
  else if(isset($_GET['formsubmitted']) &&
    $_GET['formsubmitted'] == "t")
  {
    //Connect to the database
    connect($master);

    //Filter the results, but first check to see if magic quotes
    // is on, this affects the regex-matching with unknown escaped
    // strings.
    if(get_magic_quotes_gpc())
    {
      foreach(array_keys($_POST) as $field)
      {
        $_POST[$field] = stripslashes($_POST[$field]);
      }
    }
    foreach(array_keys($_POST) as $field)
    {
      $_POST[$field] = mysql_real_escape_string($_POST[$field]);
    }

    //Simple validation
    if(isset($_POST['firstName']) && $_POST['firstName'] != "" &&
      isset($_POST['lastName']) && $_POST['lastName'] != "" &&
      isset($_POST['email']) && $_POST['email'] != "")
    {
      //Validate the email address
      // Regex adapted from one found at http://regexlib.com/
      $emailRegEx = "^[A-Za-z0-9](([_\.\-]?[a-zA-Z0-9]+)*)@(([A-Za-z0-9_\-]+[\.])*)(udel\.edu)^";
      $nameRegEx = "/^[a-zA-Z](((['\-]?)[a-zA-Z])*)$/";

      if(preg_match($emailRegEx,$_POST['email']))
      {
        $validEmail = true;

        //Now check to see if that email already exists
        $doubleCheckQuery = "SELECT * FROM users WHERE email='" .
          $_POST['email'] . "'";

        $result = mysql_query($doubleCheckQuery);
        if(!$result || mysql_num_rows($result) != 0)
        {
          //Found the same email in the system
          $validEmail = false;
        }
      }
      else
      {
        //Invalid email address
        $validEmail = false;
      }

      if(preg_match($nameRegEx,$_POST['firstName']))
      {
        $validFirstName = true;
      }
      else
      {
        $validFirstName = false;
      }

      if(preg_match($nameRegEx,stripslashes($_POST['lastName'])))
      {
        $validLastName = true;
      }
      else
      {
        $validLastName = false;
      }

      //Build passwords and authStrings
      if($validEmail && $validFirstName && $validLastName)
      {
        $password = $_POST['email'] . time();
        $password = sha1($password);
        $password = base64_encode($password);

        $eightCharPasswordRegEx = "/^......../";
        $matchesArray = array();
        preg_match($eightCharPasswordRegEx,$password,$matchesArray);

        $insertPassword = $matchesArray[0];

        $authString = $_POST['email'] . time() . time();
        $authString = base64_encode(sha1($authString));

        $authStringRegEx = "/[^=]*/";
        preg_match($authStringRegEx,$authString,$matchesArray);

        $insertAuthString = $matchesArray[0];

        //Now, add the new user
        $insertQuery = "INSERT INTO users (firstName,lastName," .
          "email,password,authString) VALUES ('{$_POST['firstName']}'," .
          "'{$_POST['lastName']}','{$_POST['email']}','{$insertPassword}'," .
          "'{$insertAuthString}')";

        $result = mysql_query($insertQuery);
        if($result)
        {
          //Send the mail, then automatically authenticate the user
          // using the authString method and authenticate.php
          $redirectString = "authenticate.php?authType=std&" .
            "email={$_POST['email']}&" .
            "authString=" . $insertAuthString;

          //Construct and send an email with login info
          $emailTo = $_POST['email'];
          $emailSubject = $master['systemName'] . ": New Account " .
            "Login Information";
          $emailHeaders = "From: " . $master['adminEmail'] . "\r\n" .
            "MIME-Version: 1.0\r\n" .
            "Content-type: text/html; charset=iso-8859-1\r\n";
          $emailBody = "<html>
  <body>
    <p>
      Dear {$_POST['firstName']},
    </p>
    <p>
      Thank you for signing up for the {$master['systemName']}!<br />
      There are two ways you can log into this system:
    </p>
    <p>
      (1) By visiting this <a href=\"{$master['systemRoot']}\">web page</a> and entering the following credentials:<br />
      Your login credentials are:<br />
      <b>Email:</b> {$emailTo}<br />
      <b>Password:</b> {$insertPassword}
    </p>
    <p>
      (2) By visiting this <a href=\"{$master['systemRootURL']}{$master['systemRoot']}authenticate.php?authType=std&amp;email={$_POST['email']}&amp;authString={$insertAuthString}\">web page</a><br />
      The following URL is the same page pointed to by the above link.  You may bookmark it by copying and pasting it into your browser's bookmark menu.<br />
      <b>URL:</b> {$master['systemRootURL']}{$master['systemRoot']}authenticate.php?authType=std&amp;email={$_POST['email']}&amp;authString={$insertAuthString}
    </p>
    <p>
      Sincerely,<br />
      {$master['admin']}
    </p>
  </body>
</html>";


          //Mail and redirect
          mail($emailTo,$emailSubject,$emailBody,$emailHeaders);
          header("Location: " . $redirectString);
        }
        else
        {
          //Error
          header("Location: " . $_SERVER['PHP_SELF'] . "?error=query");
        }
      }
      else
      {
        //Deeper validation failed
        header("Location: " . $_SERVER['PHP_SELF'] . "?error=registerForm");
      }
    }

    //Initial validation failed
    else
    {
      header("Location: " . $_SERVER['PHP_SELF'] . "?error=registerForm");
    }
  }

  //Else redirect (bad page)
  else
  {
    header("Location: " . $master['systemRoot'] . "?error=badPage");
  }
?>